#pragma once
struct DirectSound8;
class DirectSoundCapture8;
class DirectSoundEnum8;
class DirectSoundPrimaryBuffer8;
class DirectSound3DBuffer8;
class DirectInput8;
class DirectMusicLoader8;
class DirectMusicComposer8;
class DirectMusicPerformance8;
class DirectXEvent8;
class DirectPlayVoiceClient8;
class DirectPlayVoiceServer8;
class DirectPlayVoiceTest8;
class DirectXFile;
class DirectPlay8Peer;
class DirectPlay8Server;
class DirectPlay8Client;
class DirectPlay8Address;
class Direct3D8;
class DirectPlay8LobbyClient;
class DirectPlay8LobbiedApplication;

typedef enum {
	vbDSBPLAY_DEFAULT = 0,
	vbDSBPLAY_LOOPING = 1,
	vbDSBPLAY_LOCHARDWARE = 2,
	vbDSBPLAY_LOCSOFTWARE = 4,
	vbDSBPLAY_TERMINATEBY_TIME = 8,
	vbDSBPLAY_TERMINATEBY_DISTANCE = 16,
	vbDSBPLAY_TERMINATEBY_PRIORITY = 32
} CONST_DSBPLAYFLAGS;

typedef enum {
	vbDSBLOCK_DEFAULT = 0,
	vbDSBLOCK_FROMWRITECURSOR = 1,
	vbDSBLOCK_ENTIREBUFFER = 2
} CONST_DSBLOCKFLAGS;

typedef enum {
	vbDSBSTATUS_PLAYING = 1,
	vbDSBSTATUS_BUFFERLOST = 2,
	vbDSBSTATUS_LOOPING = 4,
	vbDSBSTATUS_LOCHARDWARE = 8,
	vbDSBSTATUS_LOCSOFTWARE = 16,
	vbDSBSTATUS_TERMINATED = 32
} CONST_DSBSTATUSFLAGS;

typedef enum {
	vbDSSCL_NORMAL = 1,
	vbDSSCL_PRIORITY = 2,
	vbDSSCL_WRITEPRIMARY = 4
} CONST_DSSCLFLAGS;

typedef enum {
	vbDSSPEAKER_HEADPHONE = 1,
	vbDSSPEAKER_MONO = 2,
	vbDSSPEAKER_QUAD = 3,
	vbDSSPEAKER_STEREO = 4,
	vbDSSPEAKER_SURROUND = 5,
	vbDSSPEAKER_GEOMETRY_MIN = 5,
	vbDSSPEAKER_GEOMETRY_NARROW = 10,
	vbDSSPEAKER_GEOMETRY_WIDE = 20,
	vbDSSPEAKER_GEOMETRY_MAX = 180
} CONST_DSSPEAKERFLAGS;

typedef enum {
	vbDSCAPS_PRIMARYMONO = 1,
	vbDSCAPS_PRIMARYSTEREO = 2,
	vbDSCAPS_PRIMARY8BIT = 4,
	vbDSCAPS_PRIMARY16BIT = 8,
	vbDSCAPS_CONTINUOUSRATE = 16,
	vbDSCAPS_EMULDRIVER = 32,
	vbDSCAPS_CERTIFIED = 64,
	vbDSCAPS_SECONDARYMONO = 256,
	vbDSCAPS_SECONDARYSTEREO = 512,
	vbDSCAPS_SECONDARY8BIT = 1024,
	vbDSCAPS_SECONDARY16BIT = 2048
} CONST_DSCAPSFLAGS;

typedef enum {
	vbDSBCAPS_PRIMARYBUFFER = 1,
	vbDSBCAPS_STATIC = 2,
	vbDSBCAPS_LOCHARDWARE = 4,
	vbDSBCAPS_LOCSOFTWARE = 8,
	vbDSBCAPS_CTRL3D = 16,
	vbDSBCAPS_CTRLFREQUENCY = 32,
	vbDSBCAPS_CTRLPAN = 64,
	vbDSBCAPS_CTRLVOLUME = 128,
	vbDSBCAPS_CTRLPOSITIONNOTIFY = 256,
	vbDSBCAPS_CTRLFX = 512,
	vbDSBCAPS_CTRLCHANNELVOLUME = 1024,
	vbDSBCAPS_STICKYFOCUS = 16384,
	vbDSBCAPS_GLOBALFOCUS = 32768,
	vbDSBCAPS_GETCURRENTPOSITION2 = 0x00010000,
	vbDSBCAPS_MUTE3DATMAXDISTANCE = 0x00020000,
	vbDSBCAPS_LOCDEFER = 0x00040000
} CONST_DSBCAPSFLAGS;

typedef struct tagDSBUFFERDESC {
	long lSize;  
	CONST_DSBCAPSFLAGS lFlags;   
	long lBufferBytes;   
	long lReserved;
	WAVEFORMATEX fxFormat;
	BSTR guid3DAlgorithm;
} VBDSBUFFERDESC;

typedef struct tagDSCAPS {
	long lSize;
	CONST_DSCAPSFLAGS lFlags;
	long lMinSecondarySampleRate;
	long lMaxSecondarySampleRate;
	long lPrimaryBuffers;
	long lMaxHwMixingAllBuffers;
	long lMaxHwMixingStaticBuffers;
	long lMaxHwMixingStreamingBuffers;
	long lFreeHwMixingAllBuffers;
	long lFreeHwMixingStaticBuffers;
	long lFreeHwMixingStreamingBuffers;
	long lMaxHw3DAllBuffers;
	long lMaxHw3DStaticBuffers;
	long lMaxHw3DStreamingBuffers;
	long lFreeHw3DAllBuffers;
	long lFreeHw3DStaticBuffers;
	long lFreeHw3DStreamingBuffers;
	long lTotalHwMemBytes;
	long lFreeHwMemBytes;
	long lMaxContigFreeHwMemBytes;
	long lUnlockTransferRateHwBuffers;
	long lPlayCpuOverheadSwBuffers;
	long lReserved1;
	long lReserved2;
} VBDSCAPS;

typedef struct tagDSBCAPS {
	long lSize; 
	CONST_DSBCAPSFLAGS lFlags;
	long lBufferBytes;
	long lUnlockTransferRate;
	long lPlayCpuOverhead;
} VBDSBCAPS;

typedef struct tagDSCURSORS {
	long lPlay;
	long lWrite;
} VBDSCURSORS;

MIDL_INTERFACE("9F76FB01-8E92-11D1-8808-00C04FC2C603")
DirectSoundSecondaryBuffer8 : public IUnknown {
    /* [hidden] */
    virtual HRESULT STDMETHODCALLTYPE InternalSetObject(/* [in] */ IUnknown* lpdd) = 0;
    /* [hidden] */
    virtual HRESULT STDMETHODCALLTYPE InternalGetObject(/* [out, retval] */ IUnknown** lpdd) = 0;
    /* [helpcontext(0x00013ff4)] */
    virtual HRESULT STDMETHODCALLTYPE GetDirectSound3DBuffer(/* [out, retval] */ DirectSound3DBuffer8** lpdsb) = 0;
    /* [helpcontext(0x00013ff2)] */
    virtual HRESULT STDMETHODCALLTYPE GetCaps(/* [in, out] */ VBDSBCAPS* Caps) = 0;
    /* [helpcontext(0x00013ff3)] */
    virtual HRESULT STDMETHODCALLTYPE GetCurrentPosition(/* [out] */ VBDSCURSORS* cursors) = 0;
    /* [helpcontext(0x00013ff5)] */
    virtual HRESULT STDMETHODCALLTYPE GetFormat(/* [in, out] */ WAVEFORMATEX* Format) = 0;
    /* [helpcontext(0x00013ffa)] */
    virtual HRESULT STDMETHODCALLTYPE GetVolume(/* [out, retval] */ long* volume) = 0;
    /* [helpcontext(0x00013ff8)] */
    virtual HRESULT STDMETHODCALLTYPE GetPan(/* [out, retval] */ long* pan) = 0;
    /* [helpcontext(0x00013ff6)] */
    virtual HRESULT STDMETHODCALLTYPE GetFrequency(/* [out, retval] */ long* frequency) = 0;
    /* [helpcontext(0x00013ff9)] */
    virtual HRESULT STDMETHODCALLTYPE GetStatus(/* [out, retval] */ CONST_DSBSTATUSFLAGS* status) = 0;
    /* [hidden] */
    virtual HRESULT STDMETHODCALLTYPE Initialize(
                    /* [in] */ DirectSound8* directSound, 
                    /* [in, out] */ VBDSBUFFERDESC* bufferDesc, 
                    /* [in, out] */ unsigned char* wbuf) = 0;
    /* [helpcontext(0x00014006)] */
    virtual HRESULT STDMETHODCALLTYPE WriteBuffer(
                    /* [in] */ long Start, 
                    /* [in] */ long Size, 
                    /* [in] */ void* Buffer, 
                    /* [in] */ CONST_DSBLOCKFLAGS flags) = 0;
    /* [helpcontext(0x00013cdc)] */
    virtual HRESULT STDMETHODCALLTYPE ReadBuffer(
                    /* [in] */ long Start, 
                    /* [in] */ long Size, 
                    /* [in] */ void* Buffer, 
                    /* [in] */ CONST_DSBLOCKFLAGS flags) = 0;
    /* [helpcontext(0x00013ffb)] */
    virtual HRESULT STDMETHODCALLTYPE Play(/* [in] */ CONST_DSBPLAYFLAGS flags) = 0;
    /* [helpcontext(0x00013fff)] */
    virtual HRESULT STDMETHODCALLTYPE SetCurrentPosition(/* [in] */ long newPosition) = 0;
    /* [helpcontext(0x00014004)] */
    virtual HRESULT STDMETHODCALLTYPE SetVolume(/* [in] */ long volume) = 0;
    /* [helpcontext(0x00014003)] */
    virtual HRESULT STDMETHODCALLTYPE SetPan(/* [in] */ long pan) = 0;
    /* [helpcontext(0x00014000)] */
    virtual HRESULT STDMETHODCALLTYPE SetFrequency(/* [in] */ long frequency) = 0;
    /* [helpcontext(0x00014005)] */
    virtual HRESULT STDMETHODCALLTYPE Stop() = 0;
    /* [helpcontext(0x00013ffd)] */
    virtual HRESULT STDMETHODCALLTYPE Restore() = 0;
    /* [helpcontext(0x00014002)] */
    virtual HRESULT STDMETHODCALLTYPE SetNotificationPositions(
                    long nElements, 
                    SAFEARRAY(VBDSBPOSITIONNOTIFY)* psa) = 0;
    /* [helpcontext(0x00013ffe)] */
    virtual HRESULT STDMETHODCALLTYPE SaveToFile(/* [in] */ BSTR filename) = 0;
    /* [helpcontext(0x00014001)] */
    virtual HRESULT STDMETHODCALLTYPE SetFX(
                    /* [in] */ long lEffectsCount, 
                    SAFEARRAY(VBDSEFFECTDESC)* Buffers, 
                    SAFEARRAY(long)* lResultIDs) = 0;
    /* [helpcontext(0x00013ff1)] */
    virtual HRESULT STDMETHODCALLTYPE AcquireResources(
                    /* [in] */ long lFlags, 
                    /* [in, out] */ SAFEARRAY(long)* lEffectsResults) = 0;
    /* [helpcontext(0x00013ff7)] */
    virtual HRESULT STDMETHODCALLTYPE GetObjectinPath(
                    /* [in] */ BSTR guidFX, 
                    /* [in] */ long lIndex, 
                    /* [in] */ BSTR iidInterface, 
                    /* [out, retval] */ IUnknown** ret) = 0;
};

MIDL_INTERFACE("9F76FB00-8E92-11D1-8808-00C04FC2C603")
DirectSound8 : public IUnknown {
	/* [hidden] */
	virtual HRESULT STDMETHODCALLTYPE InternalSetObject(
		/* [in] */ IUnknown* lpdd) = 0;
	/* [hidden] */
	virtual HRESULT STDMETHODCALLTYPE InternalGetObject(
		/* [out, retval] */ IUnknown** lpdd) = 0;
	/* [helpcontext(0x00013f9f)] */
	virtual HRESULT STDMETHODCALLTYPE CreateSoundBuffer(
					/* [in] */ VBDSBUFFERDESC* bufferDesc, 
					/* [out, retval] */ DirectSoundSecondaryBuffer8** soundBuffer) = 0;
	/* [helpcontext(0x00013fa0)] */
	virtual HRESULT STDMETHODCALLTYPE CreateSoundBufferFromFile(
					/* [in] */ BSTR filename, 
					/* [in, out] */ VBDSBUFFERDESC* bufferDesc, 
					/* [out, retval] */ DirectSoundSecondaryBuffer8** soundBuffer) = 0;
	/* [helpcontext(0x00013fa1)] */
	virtual HRESULT STDMETHODCALLTYPE CreateSoundBufferFromResource(
					/* [in] */ BSTR dll, 
					/* [in] */ BSTR resourceName, 
					/* [in, out] */ VBDSBUFFERDESC* bufferDesc, 
					/* [out, retval] */ DirectSoundSecondaryBuffer8** soundBuffer) = 0;
	/* [helpcontext(0x00013fa3)] */
	virtual HRESULT STDMETHODCALLTYPE GetCaps(
		/* [in, out] */ VBDSCAPS* Caps) = 0;
	/* [helpcontext(0x00013fa2)] */
	virtual HRESULT STDMETHODCALLTYPE DuplicateSoundBuffer(
					/* [in] */ DirectSoundSecondaryBuffer8* original, 
					/* [out, retval] */ DirectSoundSecondaryBuffer8** Duplicate) = 0;
	/* [helpcontext(0x00013fa5)] */
	virtual HRESULT STDMETHODCALLTYPE SetCooperativeLevel(
					/* [in] */ long hwnd, 
					/* [in] */ CONST_DSSCLFLAGS Level) = 0;
	/* [helpcontext(0x00013fa4)] */
	virtual HRESULT STDMETHODCALLTYPE GetSpeakerConfig(
		/* [out, retval] */ CONST_DSSPEAKERFLAGS* speakerConfig) = 0;
	/* [helpcontext(0x00013fa6)] */
	virtual HRESULT STDMETHODCALLTYPE SetSpeakerConfig(
		/* [in] */ CONST_DSSPEAKERFLAGS speakerConfig) = 0;
	/* [helpcontext(0x00013f9e)] */
	virtual HRESULT STDMETHODCALLTYPE CreatePrimarySoundBuffer(
					/* [in] */ VBDSBUFFERDESC* bufferDesc, 
					/* [out, retval] */ DirectSoundPrimaryBuffer8** soundBuffer) = 0;
};

MIDL_INTERFACE("E7FF1301-96A5-11D3-AC85-00C04FC2C602")
IDirectX8 : public IUnknown {
	/* [helpcontext(0x00015004)] */
	virtual HRESULT STDMETHODCALLTYPE DirectSoundCreate(
					/* [in] */ BSTR guid, 
					/* [out, retval] */ DirectSound8** ret) = 0;
	/* [helpcontext(0x00015003)] */
	virtual HRESULT STDMETHODCALLTYPE DirectSoundCaptureCreate(
					/* [in] */ BSTR guid, 
					/* [out, retval] */ DirectSoundCapture8** ret) = 0;
	/* [helpcontext(0x00015007)] */
	virtual HRESULT STDMETHODCALLTYPE GetDSEnum(
		/* [out, retval] */ DirectSoundEnum8** retVal) = 0;
	/* [helpcontext(0x00015006)] */
	virtual HRESULT STDMETHODCALLTYPE GetDSCaptureEnum(
		/* [out, retval] */ DirectSoundEnum8** retVal) = 0;
	/* [helpcontext(0x000153ee)] */
	virtual HRESULT STDMETHODCALLTYPE DirectInputCreate(
		/* [out, retval] */ DirectInput8** ret) = 0;
	/* [helpcontext(0x00014ff8)] */
	virtual HRESULT STDMETHODCALLTYPE DirectMusicLoaderCreate(
		/* [out, retval] */ DirectMusicLoader8** ret) = 0;
	/* [helpcontext(0x00014ff7)] */
	virtual HRESULT STDMETHODCALLTYPE DirectMusicComposerCreate(
		/* [out, retval] */ DirectMusicComposer8** ret) = 0;
	/* [helpcontext(0x00014ff9)] */
	virtual HRESULT STDMETHODCALLTYPE DirectMusicPerformanceCreate(
		/* [out, retval] */ DirectMusicPerformance8** ret) = 0;
	/* [helpcontext(0x00015009)] */
	virtual HRESULT STDMETHODCALLTYPE CreateEvent(
					/* [in] */ DirectXEvent8* event, 
					/* [out, retval] */ long* h) = 0;
	/* [helpcontext(0x00015008)] */
	virtual HRESULT STDMETHODCALLTYPE SetEvent(
		/* [in] */ long eventid) = 0;
	/* [helpcontext(0x00014ff4)] */
	virtual HRESULT STDMETHODCALLTYPE DestroyEvent(
		/* [in] */ long eventid) = 0;
	/* [helpcontext(0x00014ff3)] */
	virtual HRESULT STDMETHODCALLTYPE CreateNewGuid(
		/* [out, retval] */ BSTR* retGuid) = 0;
	/* [helpcontext(0x00015000)] */
	virtual HRESULT STDMETHODCALLTYPE DirectPlayVoiceClientCreate(
		/* [out, retval] */ DirectPlayVoiceClient8** ret) = 0;
	/* [helpcontext(0x00015001)] */
	virtual HRESULT STDMETHODCALLTYPE DirectPlayVoiceServerCreate(
		/* [out, retval] */ DirectPlayVoiceServer8** ret) = 0;
	/* [helpcontext(0x00015002)] */
	virtual HRESULT STDMETHODCALLTYPE DirectPlayVoiceTestCreate(
		/* [out, retval] */ DirectPlayVoiceTest8** ret) = 0;
	/* [helpcontext(0x00015249)] */
	virtual HRESULT STDMETHODCALLTYPE DirectXFileCreate(
		/* [out, retval] */ DirectXFile** ret) = 0;
	/* [helpcontext(0x00014ffe)] */
	virtual HRESULT STDMETHODCALLTYPE DirectPlayPeerCreate(
		/* [out, retval] */ DirectPlay8Peer** ret) = 0;
	/* [helpcontext(0x00014fff)] */
	virtual HRESULT STDMETHODCALLTYPE DirectPlayServerCreate(
		/* [out, retval] */ DirectPlay8Server** ret) = 0;
	/* [helpcontext(0x00014ffb)] */
	virtual HRESULT STDMETHODCALLTYPE DirectPlayClientCreate(
		/* [out, retval] */ DirectPlay8Client** ret) = 0;
	/* [helpcontext(0x00014ffa)] */
	virtual HRESULT STDMETHODCALLTYPE DirectPlayAddressCreate(
		/* [out, retval] */ DirectPlay8Address** ret) = 0;
	/* [helpcontext(0x00014ff5)] */
	virtual HRESULT STDMETHODCALLTYPE Direct3DCreate(
		/* [out, retval] */ Direct3D8** ret) = 0;
	/* [helpcontext(0x00014ffd)] */
	virtual HRESULT STDMETHODCALLTYPE DirectPlayLobbyClientCreate(
		/* [out, retval] */ DirectPlay8LobbyClient** ret) = 0;
	/* [helpcontext(0x00014ffc)] */
	virtual HRESULT STDMETHODCALLTYPE DirectPlayLobbiedApplicationCreate(
		/* [out, retval] */ DirectPlay8LobbiedApplication** ret) = 0;
};